//
//  TaskLauncher.m
//  mac_audit
//

#import "TaskLauncher.h"


@implementation TaskLauncher

- (NSData *)launchTask: (NSString *) taskCommand
{
    NSMutableDictionary *environnement = [[NSMutableDictionary alloc] initWithDictionary:[[NSProcessInfo processInfo] environment]];
    NSTask *task = [[NSTask alloc] init];      
    [task setEnvironment:environnement];
    NSPipe *stdoutPipe = [NSPipe pipe];
    NSFileHandle *stdoutFile = [stdoutPipe fileHandleForReading];    
    [task setStandardOutput:stdoutPipe];
    
    [task setLaunchPath: taskCommand];
    [task launch];
    [task waitUntilExit];
    return [stdoutFile readDataToEndOfFile];
}

- (NSData *)launchTask: (NSString *) taskCommand withArguments: (NSArray *)args
{
    NSString *outFileName = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:@"nstask.tmp"];
    
    if ([[NSFileManager defaultManager] fileExistsAtPath:outFileName])
        [[NSFileManager defaultManager] removeItemAtPath:outFileName error:NULL];
    
    [[NSFileManager defaultManager] createFileAtPath:outFileName contents:NULL attributes:NULL];
    
    NSFileHandle *outFile = [NSFileHandle fileHandleForWritingAtPath:outFileName];
    
    NSMutableDictionary *environnement = [[NSMutableDictionary alloc] initWithDictionary:[[NSProcessInfo processInfo] environment]];
    NSTask *task = [[NSTask alloc] init];      
    [task setEnvironment:environnement];
    [task setStandardOutput:outFile];
    
    [task setLaunchPath: taskCommand];
    [task setArguments:args];
    [task launch];
    [task waitUntilExit];
  //  [outFile seekToFileOffset:0];
    [outFile closeFile];
    NSData *returnData = [NSData dataWithContentsOfFile:outFileName];
    [[NSFileManager defaultManager] removeItemAtPath:outFileName error:NULL];
    
    return returnData;
}



@end
